////////////////////////////////////////////////////////////////////////////////
/// @brief force symbols into programm
///
/// @file
///
/// DISCLAIMER
///
/// Copyright 2010-2011 triagens GmbH, Cologne, Germany
///
/// Licensed under the Apache License, Version 2.0 (the "License");
/// you may not use this file except in compliance with the License.
/// You may obtain a copy of the License at
///
///     http://www.apache.org/licenses/LICENSE-2.0
///
/// Unless required by applicable law or agreed to in writing, software
/// distributed under the License is distributed on an "AS IS" BASIS,
/// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
/// See the License for the specific language governing permissions and
/// limitations under the License.
///
/// Copyright holder is triAGENS GmbH, Cologne, Germany
///
/// @author Dr. Frank Celler
/// @author Copyright 2009-2010, triAGENS GmbH, Cologne, Germany
////////////////////////////////////////////////////////////////////////////////

#include "Basics.h"
#include "Rest.h"
#include "Hpdf.h"


namespace triagens {
  namespace hpdf {
    namespace {
      class InitDummy : public triagens::hpdf::Table {
        public:
          size_t size () const {return 0;}
          void reserve (size_t) {}
          triagens::hpdf::Row const* add (triagens::hpdf::Row const *) {return 0;}
          void forall (triagens::hpdf::TableVisitor *) const {}
          void forany (triagens::hpdf::TableVisitor *) const {}
      };


    }

    void InitialiseStorage () {
      TRIAGENS_REST_INITIALISE;

      InitDummy* dummy = new InitDummy;
      delete dummy;



      VariantRow::initialise();

      hpdf::revision();



    }
  }
}
