////////////////////////////////////////////////////////////////////////////////
/// @brief flush all data request handler
///
/// @file
///
/// DISCLAIMER
///
/// Copyright 2010-2011 triagens GmbH, Cologne, Germany
///
/// Licensed under the Apache License, Version 2.0 (the "License");
/// you may not use this file except in compliance with the License.
/// You may obtain a copy of the License at
///
///     http://www.apache.org/licenses/LICENSE-2.0
///
/// Unless required by applicable law or agreed to in writing, software
/// distributed under the License is distributed on an "AS IS" BASIS,
/// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
/// See the License for the specific language governing permissions and
/// limitations under the License.
///
/// Copyright holder is triAGENS GmbH, Cologne, Germany
///
/// @author Achim Brandt
/// @author Copyright 2010, triagens GmbH, Cologne, Germany
////////////////////////////////////////////////////////////////////////////////

#include "RestFlushHandler.h"

using namespace triagens::rest;

namespace triagens {
  namespace simple {

    // -----------------------------------------------------------------------------
    // Handler methods
    // -----------------------------------------------------------------------------

    HttpHandler::status_e RestFlushHandler::execute() {
      Value value;
      RestDefaultHandler::ParseErrorType parseResult
      = datetimeHeaderField("X-VOC-Flush-Delay",value.flushDelay);

      if (parseResult == PARSE_ERROR) {
        generateError("invalid flush date time");
        return HANDLER_DONE;
      }

      ResponseType result = model->flushAllValue(value);

      if (result == OK) {
        generateStatus("flush started");
      }
      else {
        generateError("flush error");
      }

      return HANDLER_DONE;
    }
  }
}
